import java.util.*;

//***********************************************************************************
/** Class to return iterate of Sine map function.<br>
*/
//***********************************************************************************

public class SineFunction extends Map1DFunction {
      private static final double Pi=Math.PI;

      SineFunction() {
           nParameters=1;
           a=new double[nParameters];
            aDefault = new double [nParameters];
            aDefault[0]=3.86;
            aMinimum=0.;
            aMaximum=4.;
            enforceARange=true;
            x0Default=0.2;
            title = "Sine Map";              
      }
      
      public double evaluateFunction(double x) {            
            return 0.25*a[0]*Math.sin(Pi*x);
      }
      
      public double evaluateDerivative(double x) {            
            return 0.25*Pi*a[0]*Math.cos(Pi*x);
      }           
}



