import java.util.*;
//***********************************************************************************
/** Class to return iterate of Tent map function.<br>
*/
//***********************************************************************************

public class TentFunction extends Map1DFunction {
      private static final double Pi=Math.PI;

      TentFunction() {
            nParameters=1;
            a=new double[nParameters];
            aDefault = new double [nParameters];
            aDefault[0]=1.7;
            aMinimum=0.;
            aMaximum=2.;
            enforceARange=true;
            x0Default=0.2;
            title = "Tent Map";   
      }
      
      public double evaluateFunction(double x) {                        
            if(x<0.5) x=a[0]*x;
            else x=a[0]*(1-x);
            return x;
      }
      
      public double evaluateDerivative(double x) {            
            if(x<0.5) return a[0];
            else return -a[0];            
      }      
}



